package com.ai.ipu.cache.jvm;

import java.util.HashMap;

import com.ai.ipu.cache.ICache;

/**
 * JVM缓存
 */
public class JCache implements ICache{
    private HashMap cacheMap; //缓存

    public JCache(){
        cacheMap = new HashMap();
    }
    
    /**
     * 在jvm缓存中存放一个K-V键值对
     * @param key  key值
     * @param value value值
     * @return 
     * @exception Exception
     */
    public boolean put(Object key, Object value) throws Exception {    
        return cacheMap.put(key, value) != null;
    }

    /**
     * 在jvm缓存中得到key的value值
     * @param key  key值
     * @return Object value值
     * @exception Exception
     */
    public Object get(Object key) throws Exception {
        return cacheMap.get(key);
    }

    /**
     * 在jvm缓存中移除key
     * @param key  key值
     * @return boolean
     * @exception Exception
     */
    public boolean remove(Object key) throws Exception {
        Object value = cacheMap.remove(key);
        return value!=null;
    }

    /**
     * 清除jvm缓存所有值
     * @exception Exception
     */
    public void clear() throws Exception {
        cacheMap.clear();
    }

    @Override
    public boolean keyExists(String cacheKey) {
        return cacheMap.containsKey(cacheKey);
    }

    @Override
    public boolean put(Object key, Object value, int secondTimeout) throws Exception {
        return false;
    }
}
