package com.ai.ipu.cache.mem.impl;

import com.ai.ipu.cache.mem.IMemCache;

/**
 * wade MemCache实现
 */
public class WadeMemCache implements IMemCache{
	private com.ailk.cache.memcache.interfaces.IMemCache memCache;

	/**
	 * 构造器
	 * @param memCache 代理的对象
	 */
	public WadeMemCache(com.ailk.cache.memcache.interfaces.IMemCache memCache){
		this.memCache = memCache;
	}

	/**
	 * 存储数据
     * @return 是否存储成功
	 */
	public boolean put(Object key, Object value) throws Exception {
		// TODO Auto-generated method stub
		return memCache.set((String) key, value);
	}

	/**
	 * 取
     * @return 对应的缓存结果
	 */
	public Object get(Object key) throws Exception {
		// TODO Auto-generated method stub
		return memCache.get((String) key);
	}

	/**
	 * 移除
     * @return 是否移除成功
	 */
	public boolean remove(Object key) throws Exception {
		// TODO Auto-generated method stub
		return memCache.delete((String) key);
	}

	/**
	 * 清除
	 */
	public void clear() throws Exception {
		// TODO Auto-generated method stub
		if(memCache!=null){
			((MemCache)memCache).clear();
		}
	}

	/**
	 * key是否存在
     * @return key是否存在
	 */
	public boolean keyExists(String cacheKey) {
		// TODO Auto-generated method stub
		return memCache.keyExists(cacheKey);
	}

	/**
	 * 在缓存中存放一个K-V键值对，同名键会被覆盖。设置多少秒后超时
     * @return 是否put成功
	 */
	public boolean put(Object key, Object value, int secondTimeout)
			throws Exception {
		// TODO Auto-generated method stub
		return memCache.set((String)key, value, secondTimeout);
	}

	/**
	 * 递增计数器（线程安全），步长为1。
	 * @return 增加的数值
	 */
	public long incr(String cacheKey) {
		// TODO Auto-generated method stub
		return memCache.incr(cacheKey);
	}

	/**
	 * 递增计数器（线程安全），步长为inc。
     * @return 增加的数值
	 */
	public long incr(String cacheKey, int inc) {
		// TODO Auto-generated method stub
		return memCache.incr(cacheKey, inc);
	}

	/**
	 * 递减计数器（线程安全）， 步长为1。
     * @return 减少之后的数值
	 */
	public long decr(String cacheKey) {
		// TODO Auto-generated method stub
		return memCache.decr(cacheKey);
	}

	/**
	 * 递减计数器（线程安全）， 步长为inc。
     * @return 减少之后的数值
	 */
	public long decr(String cacheKey, int inc) {
		// TODO Auto-generated method stub
		return memCache.decr(cacheKey, inc);
	}

}
