package com.ai.ipu.cache.redis;

import com.ai.ipu.basic.log.ILogger;
import com.ai.ipu.basic.log.IpuLoggerFactory;
import com.ai.ipu.cache.redis.listener.AbstractPubSubListener;

public class PubSubListenerTest extends AbstractPubSubListener {
    private static final transient ILogger LOGGER = IpuLoggerFactory.createLogger(PubSubListenerTest.class);
    
    @Override
    public void onMessage(String channel, String message) {
        LOGGER.debug(String.format("receive redis published message, channel %s, message %s", channel, message));
    }

    @Override
    public void onSubscribe(String channel, int subscribedChannels) {
        LOGGER.debug(String.format("subscribe redis channel success, channel %s, subscribedChannels %d", 
                channel, subscribedChannels));
    }

    @Override
    public void onUnsubscribe(String channel, int subscribedChannels) {
        LOGGER.debug(String.format("unsubscribe redis channel, channel %s, subscribedChannels %d", 
                channel, subscribedChannels));

    }


    public void onPSubscribe(String pattern, int subscribedChannels) {  
        LOGGER.debug(pattern + "=" + subscribedChannels);  
    }  

    public void onPUnsubscribe(String pattern, int subscribedChannels) {  
        LOGGER.debug(pattern + "=" + subscribedChannels);  
    }  

    public void onPMessage(String pattern, String channel, String message) {  
        LOGGER.debug(pattern + "=" + channel + "=" + message);  
    }  

}
